#line 1 "C:/Users/branislav.marton/Desktop/Projects/StereoAmp_click/example/PIC/StereoAmp_click_PIC.c"
#line 1 "c:/users/branislav.marton/desktop/projects/stereoamp_click/example/stereoamp.h"
#line 1 "c:/users/branislav.marton/documents/mikroelektronika/mikroc pro for pic/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 46 "c:/users/branislav.marton/desktop/projects/stereoamp_click/example/stereoamp.h"
char* gain_text[] = {
 "  -80dB",
 "  -54dB",
 "-40.5dB",
 "-34.5dB",
 "  -30dB",
 "  -27dB",
 "  -24dB",
 "  -21dB",
 "  -18dB",
 "  -15dB",
 "-13.5dB",
 "  -12dB",
 "-10.5dB",
 "   -9dB",
 " -7.5dB",
 "   -6dB",
 " -4.5dB",
 "   -3dB",
 " -1.5dB",
 "    0dB",
 "  1.5dB",
 "    3dB",
 "  4.5dB",
 "    6dB",
 "  7.5dB",
 "    9dB",
 " 10.5dB",
 "   12dB",
 " 13.5dB",
 "   15dB",
 " 16.5dB",
 "   18dB"
};
#line 18 "C:/Users/branislav.marton/Desktop/Projects/StereoAmp_click/example/PIC/StereoAmp_click_PIC.c"
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;


uint8_t volume_control_L = 0;
uint8_t volume_control_R = 0;

uint8_t volume_temp = 0;

const char custom_char_1[] = {16,16,16,16,16,16,16,16};
const char custom_char_2[] = {24,24,24,24,24,24,24,24};
const char custom_char_3[] = {28,28,28,28,28,28,28,28};
const char custom_char_4[] = {30,30,30,30,30,30,30,30};
const char custom_char_5[] = {31,31,31,31,31,31,31,31};


void Generate_Custom_Chars() {
 char i;
 Lcd_Cmd(64);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_1[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);

 Lcd_Cmd(72);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_2[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);

 Lcd_Cmd(80);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_3[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);

 Lcd_Cmd(88);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_4[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);

 Lcd_Cmd(96);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_5[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);
}


uint8_t Read_Volume_Step(uint8_t channel) {
 uint16_t adc_value = ADC_Get_Sample(channel);


 adc_value &= 0x0FFF;
 return adc_value / 128;
}

void Draw_Bar(unsigned row_pos, unsigned char_pos, unsigned value) {
 unsigned i;

 Lcd_Out(row_pos, char_pos, "       ");

 for(i = 0; i < 7; i++) {
 if(value / ((i + 1) * 5) > 0) {
 Lcd_Chr(row_pos, char_pos + i, 4);
 } else {
 Lcd_Chr(row_pos, char_pos + i, value % 5);
 break;
 }
 }
}

void Write_Amp_Reg(uint8_t amp_addr, uint8_t reg_addr, uint8_t reg_data) {
 delay_ms(100);
 I2C1_Start();
 I2C1_Wr(amp_addr);
 I2C1_Wr( (reg_addr &  0b11100000 ) | (reg_data &  0b00011111 ) );
 I2C1_Stop();
}


void Init() {

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);

 Lcd_Chr(1,1, 'L');
 Lcd_Chr(2,1, 'R');

 Generate_Custom_Chars();




 TRISC = 0;
 LATC = 0x18;
 Delay_ms(300);
 LATC = 0x00;
 Delay_ms(300);

 I2C1_Init( 200000 );
 Delay_ms(800);


 Write_Amp_Reg( 0XF8 ,  0b00000000 ,  0b00010000  |  0b00000100 );
 Write_Amp_Reg( 0XFA ,  0b00000000 ,  0b00010000  |  0b00000100 );


 Write_Amp_Reg( 0XF8 ,  0b01100000 , 0);
 Write_Amp_Reg( 0XFA ,  0b01100000 , 0);


 Write_Amp_Reg( 0XF8 ,  0b01000000 ,  0b00000010  |  0b00000001  |  0b00000100  |  0b00001000  |  0b00010000 );
 Write_Amp_Reg( 0XFA ,  0b01000000 ,  0b00000010  |  0b00000001  |  0b00000100  |  0b00001000  |  0b00010000 );


 Write_Amp_Reg( 0XF8 ,  0b00100000 ,  0b00010000  |  0b00000100  |  0b00000010 );
 Write_Amp_Reg( 0XFA ,  0b00100000 ,  0b00010000  |  0b00000100  |  0b00000010 );


 ANSEL1_bit = 1;
 ANSEL6_bit = 1;

 TRISA1_bit = 1;
 TRISF1_bit = 1;

 ADC_Init();
}


void Set_Volume(char amp_addr, char value) {
 Write_Amp_Reg(amp_addr,  0b01100000 , value);
}


void main() {
 Init();

 while(1) {
 volume_temp = Read_Volume_Step( 6 );
 if(volume_temp != volume_control_L) {
 volume_control_L = volume_temp;
 Draw_Bar(2, 10, volume_control_L);
 Lcd_Out(2, 2, gain_text[volume_control_L]);
 Set_Volume( 0XF8 , volume_control_L);
 }


 volume_temp = Read_Volume_Step( 1 );
 if(volume_temp != volume_control_R) {
 volume_control_R = volume_temp;
 Draw_Bar(1, 10, volume_control_R);
 Lcd_Out(1, 2, gain_text[volume_control_R]);
 Set_Volume( 0XFA , volume_control_R);
 }

 Delay_ms( 5 );
 }
}
